"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = NepaliCalender;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _AdBsConverter = require("./AdToBsConverter/AdBsConverter");

require("./assets/app.css");

var _AppUtils = require("./utils/AppUtils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var todayTimestamp = Date.now();
var date = (0, _AppUtils.getSeparatedDateFromMilliseconds)(Date.now());
var daysMap = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthMap = ["बैशाख", "जेठ", "असार", "श्रावन", "भाद्र", "असोज", "कार्तिक", "मंसिर", "पौष", "माघ", "फाल्गुन", "चैत्र"];
var weekDaysInShort = ["आइत", "सोम", "मंगल", "बुध", "विहि", "शुक्र", "शनि"];
var monthMapInEnglish = ["Baishakh", "Jestha", "Asar", "Shrawan", "Bhadra", "Ashwin", "Kartik", "Mangsir", "Poush", "Magh", "Falgun", "Chaitra"];
var weekDaysInShortInEnglish = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];

function NepaliCalender(props) {
  var inputRef = (0, _react.useRef)();
  var datePickerRef = (0, _react.useRef)(null);

  var _useState = (0, _react.useState)(date.year),
      _useState2 = _slicedToArray(_useState, 2),
      year = _useState2[0],
      setYear = _useState2[1];

  var _useState3 = (0, _react.useState)(date.month - 1),
      _useState4 = _slicedToArray(_useState3, 2),
      month = _useState4[0],
      setMonth = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      showDatePicker = _useState6[0],
      setShowDatePicker = _useState6[1];

  var _useState7 = (0, _react.useState)({}),
      _useState8 = _slicedToArray(_useState7, 2),
      invalidDateError = _useState8[0],
      setInvalidDateError = _useState8[1];

  var _useState9 = (0, _react.useState)(todayTimestamp),
      _useState10 = _slicedToArray(_useState9, 2),
      selectedDay = _useState10[0],
      setSelectedDay = _useState10[1];

  var getMonthDetails = function getMonthDetails(year, month) {
    var firstDay = _AdBsConverter.FIRST_DAY_OF_MONTH[year][month];
    var numberOfDays = getNumberOfDays(year, month);
    var monthArray = [];
    var rows = 6;
    var currentDay = null;
    var index = 0;
    var cols = 7;

    for (var row = 0; row < rows; row++) {
      for (var col = 0; col < cols; col++) {
        currentDay = getDayDetails({
          index: index,
          numberOfDays: numberOfDays,
          firstDay: firstDay,
          year: year,
          month: month
        });
        monthArray.push(currentDay);
        index++;
      }
    }

    return monthArray;
  };

  var getDayDetails = function getDayDetails(args) {
    var date = args.index - args.firstDay;
    var day = args.index % 7;
    var prevMonth = args.month - 1;
    var prevYear = args.year;

    if (prevMonth < 0 && args.year !== 1970) {
      prevMonth = 11;
      prevYear--;
    }

    var prevMonthNumberOfDays = getNumberOfDays(prevYear, prevMonth);

    var _date = (date < 0 ? prevMonthNumberOfDays + date : date % args.numberOfDays) + 1;

    var month = date < 0 ? -1 : date >= args.numberOfDays ? 1 : 0;
    var timestamp = (0, _AppUtils.getDateMilliseconds)(args.year + "-" + (args.month + 1) + "-" + _date);
    return {
      date: _date,
      day: day,
      month: month,
      timestamp: timestamp,
      dayString: daysMap[day]
    };
  };

  var getNumberOfDays = function getNumberOfDays(year, month) {
    return _AdBsConverter.calendar_data[year][month];
  };

  var _useState11 = (0, _react.useState)(getMonthDetails(date.year, date.month - 1)),
      _useState12 = _slicedToArray(_useState11, 2),
      monthDetails = _useState12[0],
      setMonthDetails = _useState12[1];

  (0, _react.useEffect)(function () {
    var addBackDrop = function addBackDrop(e) {
      var _datePickerRef$curren;

      if (!((_datePickerRef$curren = datePickerRef.current) !== null && _datePickerRef$curren !== void 0 && _datePickerRef$curren.contains(e.target))) {
        setShowDatePicker(false);
      }
    };

    if (showDatePicker) {
      window.addEventListener("click", addBackDrop);
    }

    return function () {
      window.removeEventListener("click", addBackDrop);
    };
  }, [showDatePicker]);
  (0, _react.useEffect)(function () {
    if (props.defaultFormat ? props.defaultDate : !isNaN(props.defaultDate) && props.defaultDate !== null) {
      var dateObject;
      var defaultDate;

      if (props.defaultFormat) {
        dateObject = (0, _AppUtils.getSeparatedDateFromBsDate)(props.defaultDate);
        defaultDate = (0, _AppUtils.getDateMilliseconds)(props.defaultDate);
      } else {
        dateObject = (0, _AppUtils.getSeparatedDateFromMilliseconds)(props.defaultDate);
        defaultDate = props.defaultDate;
      }

      setYear(dateObject.year);
      setMonth(dateObject.month);
      updateDateToInput(defaultDate);
      updateDateFromInput();
    }
  }, [props.defaultDate]);
  (0, _react.useEffect)(function () {
    if (props.showDefaultDate && (props.defaultFormat ? !props.defaultDate : isNaN(props.defaultDate) || props.defaultDate === null)) {
      updateDateToInput(selectedDay);
      updateDateFromInput();
    }
  }, [props.showDefaultDate]);

  var isCurrentDay = function isCurrentDay(day) {
    return day.month === 0 && (0, _AppUtils.getDateFromMilliseconds)(day.timestamp) === (0, _AppUtils.getDateFromMilliseconds)(todayTimestamp);
  };

  var isSelectedDay = function isSelectedDay(day) {
    return day.month === 0 && day.timestamp === selectedDay;
  };

  var getDateFromDateString = function getDateFromDateString(dateValue) {
    var dateData = dateValue.split("-").map(function (d) {
      return parseInt(d, 10);
    });

    if (dateData.length < 3 || !(dateData[0] > 1969 && dateData[0] < 2100) || !(dateData[1] > 0 && dateData[1] < 13) || !(dateData[2] > 0 && dateData[2] <= _AdBsConverter.calendar_data[dateData[0]][dateData[1] - 1])) {
      if (!!dateValue) {
        dateData.length < 3 ? setInvalidDateError({
          invalidFormat: true
        }) : dateData[0] < 1970 ? setInvalidDateError({
          minDateError: true
        }) : dateData[0] > 2099 ? setInvalidDateError({
          maxDateError: true
        }) : setInvalidDateError({
          invalidDate: true
        });
      }

      return null;
    }

    var year = dateData[0];
    var month = dateData[1];
    var date = dateData[2];
    return {
      year: year,
      month: month,
      date: date
    };
  };

  var getMonthStr = function getMonthStr(month) {
    return (!(props.locale === "en") ? monthMap : monthMapInEnglish)[Math.max(Math.min(11, month), 0)] || "Month";
  };

  var updateDate = function updateDate(dateData) {
    if (Boolean(dateData)) {
      var selectedDate = (0, _AppUtils.getDateMilliseconds)(dateData.year + "-" + dateData.month + "-" + dateData.date);
      setSelectedDay(selectedDate);

      if (props.onChange) {
        props.onChange(props.name, selectedDate, (0, _AppUtils.getDateFromMilliseconds)(selectedDate), (0, _AdBsConverter.BSToAD)((0, _AppUtils.getDateFromMilliseconds)(selectedDate)));
      }
    } else {
      if (props.onChange) {
        props.onChange(props.name, null, null, null);
      }
    }
  };

  var updateDateFromInput = function updateDateFromInput() {
    setInvalidDateError({});
    var dateValue = inputRef.current.value;
    var dateData = getDateFromDateString(dateValue);
    updateDate(dateData);

    if (dateData !== null) {
      setYear(dateData.year);
      setMonth(dateData.month - 1);
      setMonthDetails(getMonthDetails(dateData.year, dateData.month - 1));
    }
  };

  var updateDateToInput = function updateDateToInput(timestamp) {
    var dateString = (0, _AppUtils.getDateFromMilliseconds)(timestamp);
    inputRef.current.value = dateString;
    setInvalidDateError({});
  };

  var onDateClick = function onDateClick(day) {
    setSelectedDay(day.timestamp);
    updateDateToInput(day.timestamp);

    if (props.onChange) {
      props.onChange(props.name, day.timestamp, (0, _AppUtils.getDateFromMilliseconds)(day.timestamp), (0, _AdBsConverter.BSToAD)((0, _AppUtils.getDateFromMilliseconds)(day.timestamp)));
    }

    setShowDatePicker(false);
  };

  var updateYear = function updateYear(offset) {
    if (year > 1970 && year < 2099 || year === 1970 && offset > 0 || year === 2099 && offset < 0) {
      var updatedYear = Number(year) + offset;
      var updatedMonth = month;
      setYear(updatedYear);
      setMonthDetails(getMonthDetails(updatedYear, updatedMonth));
    } else {
      alert("माफ गर्नुहोस हामीसंग १९७० देखि २०९९ सम्मको मात्र पात्रो मात्र अवस्थित छ");
    }
  };

  var updateMonth = function updateMonth(offset) {
    var updatedYear = year;
    var updatedMonth = Number(month) + offset;

    if (updatedMonth === -1) {
      if (year > 1970) {
        updatedMonth = 11;
        updatedYear--;
      } else {
        updatedMonth -= offset;
        alert("माफ गर्नुहोस हामीसंग १९७० भन्दा कम सालको पात्रो अवस्थित छैन");
      }
    } else if (updatedMonth === 12) {
      if (year < 2099) {
        updatedMonth = 0;
        updatedYear++;
      } else {
        updatedMonth -= offset;
        alert("माफ गर्नुहोस हामीसंग २०९९ भन्दा बढी सालको पात्रो अवस्थित छैन ");
      }
    }

    setYear(updatedYear);
    setMonth(updatedMonth);
    setMonthDetails(getMonthDetails(updatedYear, updatedMonth));
  };

  var updateToCurrentDate = function updateToCurrentDate() {
    updateDateToInput(todayTimestamp);
    updateDateFromInput();
  };

  var renderCalendar = function renderCalendar() {
    var days = monthDetails.map(function (day, index) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "nc-day-container " + (day.month !== 0 ? " disabled" : "") + (isCurrentDay(day) ? " highlight" : "") + (isSelectedDay(day) ? " highlight-green" : ""),
        key: index
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "cdc-day"
      }, /*#__PURE__*/_react["default"].createElement("span", {
        onClick: function onClick() {
          return onDateClick(day);
        }
      }, props.locale === "en" ? day.date : (0, _AppUtils.replaceWithNepaliDigit)(day.date))));
    });
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "inc-container"
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "cc-head"
    }, (!(props.locale === "en") ? weekDaysInShort : weekDaysInShortInEnglish).map(function (d, i) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        key: i,
        className: "cch-name"
      }, d);
    })), /*#__PURE__*/_react["default"].createElement("div", {
      className: "cc-body"
    }, days));
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    ref: datePickerRef
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: props.inputContainerClassName
  }, /*#__PURE__*/_react["default"].createElement("input", {
    id: props.id,
    name: props.name,
    placeholder: props.placeholder,
    maxLength: props.maxLength,
    ref: inputRef,
    onChange: updateDateFromInput,
    autoComplete: props.autoComplete,
    disabled: props.disabled,
    onClick: function onClick() {
      setShowDatePicker(true);
    },
    onKeyDown: function onKeyDown(e) {
      return e.key === "Tab" ? setShowDatePicker(false) : !showDatePicker && setShowDatePicker(true);
    }
  }), /*#__PURE__*/_react["default"].createElement("label", {
    htmlFor: props.id
  }, props.label)), invalidDateError.invalidFormat && /*#__PURE__*/_react["default"].createElement("span", {
    className: "error-message"
  }, props.invalidFormatMessage), invalidDateError.maxDateError && /*#__PURE__*/_react["default"].createElement("span", {
    className: "error-message"
  }, props.maxDateErrorMessage), invalidDateError.minDateError && /*#__PURE__*/_react["default"].createElement("span", {
    className: "error-message"
  }, props.minDateErrorMessage), invalidDateError.invalidDate && /*#__PURE__*/_react["default"].createElement("span", {
    className: "error-message"
  }, props.invalidDateMessage), showDatePicker ? /*#__PURE__*/_react["default"].createElement("div", {
    className: "nc-container"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "nc-head"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "nc-button"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "nc-inner",
    onClick: function onClick() {
      return updateYear(-1);
    }
  }, /*#__PURE__*/_react["default"].createElement("p", null, /*#__PURE__*/_react["default"].createElement("strong", null, "\u219E")))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "nc-button"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "nc-inner",
    onClick: function onClick() {
      return updateMonth(-1);
    }
  }, /*#__PURE__*/_react["default"].createElement("p", null, /*#__PURE__*/_react["default"].createElement("strong", null, "\u21FD")))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "ndpch-container"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "ndpchc-year"
  }, /*#__PURE__*/_react["default"].createElement("strong", null, props.locale === "en" ? year : (0, _AppUtils.replaceWithNepaliDigit)(year))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "ndpchc-month"
  }, /*#__PURE__*/_react["default"].createElement("strong", null, getMonthStr(month)))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "nc-button"
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "nc-inner",
    onClick: function onClick() {
      return updateMonth(1);
    }
  }, /*#__PURE__*/_react["default"].createElement("p", null, /*#__PURE__*/_react["default"].createElement("strong", null, "\u21FE")))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "nc-button",
    onClick: function onClick() {
      return updateYear(1);
    }
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "nc-inner"
  }, /*#__PURE__*/_react["default"].createElement("p", null, /*#__PURE__*/_react["default"].createElement("strong", null, "\u21A0")))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "nc-button",
    onClick: updateToCurrentDate
  }, /*#__PURE__*/_react["default"].createElement("div", {
    className: "nc-inner"
  }, /*#__PURE__*/_react["default"].createElement("strong", null, "\u0906\u091C")))), /*#__PURE__*/_react["default"].createElement("div", {
    className: "nc-body"
  }, renderCalendar())) : "");
}

NepaliCalender.propTypes = {
  id: _propTypes["default"].string,
  label: _propTypes["default"].string,
  name: _propTypes["default"].string,
  backgroundColor: _propTypes["default"].string,
  showDefaultDate: _propTypes["default"].bool,
  defaultDate: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  defaultFormat: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  placeholder: _propTypes["default"].string,
  maxLength: _propTypes["default"].number,
  locale: _propTypes["default"].string,
  inputContainerClassName: _propTypes["default"].string,
  maxDateErrorMessage: _propTypes["default"].string,
  minDateErrorMessage: _propTypes["default"].string,
  invalidDateMessage: _propTypes["default"].string,
  invalidFormatMessage: _propTypes["default"].string,
  autoComplete: _propTypes["default"].string
};
NepaliCalender.defaultProps = {
  id: "nepali-calendar",
  label: "मिति",
  backgroundColor: "#fff",
  showDefaultDate: false,
  defaultFormat: false,
  disabled: false,
  placeholder: "YYYY-MM-DD",
  maxLength: 10,
  locale: "ne",
  inputContainerClassName: "input-label-container",
  maxDateErrorMessage: "२०९९ साल भन्दा बढी मिति समावेश हुने छैन",
  minDateErrorMessage: "१९७० साल भन्दा कम मिति समावेश हुने छैन",
  invalidFormatMessage: "मान्य ढाँचामा नभएको मिति समावेश हुने छैन",
  invalidDateMessage: "पात्रोमा नभएको मिति समावेश गरिने छैन",
  autoComplete: "off"
};